blob: 9aaf028ec23fa25d3d61a674aa391e57985ac046 [file] [log] [blame]
garciadeblas16304ba2016-05-11 14:47:39 +02001#!/bin/bash
2
3##
4# Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U.
5# This file is part of openmano
6# All Rights Reserved.
7#
8# Licensed under the Apache License, Version 2.0 (the "License"); you may
9# not use this file except in compliance with the License. You may obtain
10# a copy of the License at
11#
12# http://www.apache.org/licenses/LICENSE-2.0
13#
14# Unless required by applicable law or agreed to in writing, software
15# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
16# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
17# License for the specific language governing permissions and limitations
18# under the License.
19#
20# For those usages not covered by the Apache License, Version 2.0 please
21# contact with: nfvlabs@tid.es
22##
23
tierno76841842016-09-27 09:18:28 +000024#ONLY TESTED in Ubuntu 16.04 partially tested in Ubuntu 14.10 14.04 16.04, CentOS7 and RHEL7
garciadeblas16304ba2016-05-11 14:47:39 +020025#Get needed packages, source code and configure to run openmano
26#Ask for database user and password if not provided
garciadeblas16304ba2016-05-11 14:47:39 +020027
28function usage(){
tiernoc50e5da2016-07-06 17:49:45 +020029 echo -e "usage: sudo $0 [OPTIONS]"
tierno45a52852016-08-26 14:39:42 +020030 echo -e "Install last stable source code in ./openmano and the needed packages"
31 echo -e "On a Ubuntu 16.04 it configures openmano as a service"
tiernoc50e5da2016-07-06 17:49:45 +020032 echo -e " OPTIONS"
tierno45a52852016-08-26 14:39:42 +020033 echo -e " -u USER: database admin user. 'root' by default. Prompts if needed"
34 echo -e " -p PASS: database admin password to be used or installed. Prompts if needed"
garciadeblas89b3d842016-09-19 15:18:33 +020035 echo -e " -q --quiet: install in unattended mode"
tierno45a52852016-08-26 14:39:42 +020036 echo -e " -h --help: show this help"
37 echo -e " --develop: install last version for developers, and do not configure as a service"
garciadeblas89b3d842016-09-19 15:18:33 +020038 echo -e " --forcedb: reinstall mano_db DB, deleting previous database and creating a new one"
39 echo -e " --noclone: assumes that openmano was cloned previously and that this script is run from the local repo"
tierno76841842016-09-27 09:18:28 +000040 echo -e " --no-install-packages: use this option to skip updating and installing the requires packages. This avoid wasting time if you are sure requires packages are present e.g. because of a previous installation"
garciadeblas16304ba2016-05-11 14:47:39 +020041}
42
43function install_packages(){
44 [ -x /usr/bin/apt-get ] && apt-get install -y $*
tiernoc50e5da2016-07-06 17:49:45 +020045 [ -x /usr/bin/yum ] && yum install -y $*
garciadeblas16304ba2016-05-11 14:47:39 +020046
47 #check properly installed
48 for PACKAGE in $*
49 do
50 PACKAGE_INSTALLED="no"
51 [ -x /usr/bin/apt-get ] && dpkg -l $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
52 [ -x /usr/bin/yum ] && yum list installed $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
53 if [ "$PACKAGE_INSTALLED" = "no" ]
54 then
tiernoc50e5da2016-07-06 17:49:45 +020055 echo "failed to install package '$PACKAGE'. Revise network connectivity and try again" >&2
garciadeblas89b3d842016-09-19 15:18:33 +020056 exit 1
garciadeblas16304ba2016-05-11 14:47:39 +020057 fi
58 done
59}
60
garciadeblas89b3d842016-09-19 15:18:33 +020061function db_exists() {
62 RESULT=`mysqlshow --defaults-extra-file="$2" | grep -v Wildcard | grep -o $1`
63 if [ "$RESULT" == "$1" ]; then
64 echo " DB $1 exists"
65 return 0
66 fi
67 echo " DB $1 does not exist"
68 return 1
69}
70
tierno45a52852016-08-26 14:39:42 +020071GIT_URL=https://osm.etsi.org/gerrit/osm/RO.git
tiernoc50e5da2016-07-06 17:49:45 +020072DBUSER="root"
73DBPASSWD=""
74DBPASSWD_PARAM=""
75QUIET_MODE=""
tierno45a52852016-08-26 14:39:42 +020076DEVELOP=""
garciadeblas89b3d842016-09-19 15:18:33 +020077FORCEDB=""
78NOCLONE=""
tierno76841842016-09-27 09:18:28 +000079NO_PACKAGES=""
tiernoc50e5da2016-07-06 17:49:45 +020080while getopts ":u:p:hiq-:" o; do
81 case "${o}" in
82 u)
83 export DBUSER="$OPTARG"
84 ;;
85 p)
86 export DBPASSWD="$OPTARG"
87 export DBPASSWD_PARAM="-p$OPTARG"
88 ;;
89 q)
90 export QUIET_MODE=yes
91 export DEBIAN_FRONTEND=noninteractive
92 ;;
93 h)
94 usage && exit 0
95 ;;
96 -)
97 [ "${OPTARG}" == "help" ] && usage && exit 0
tierno45a52852016-08-26 14:39:42 +020098 [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
garciadeblas89b3d842016-09-19 15:18:33 +020099 [ "${OPTARG}" == "forcedb" ] && FORCEDB="y" && continue
100 [ "${OPTARG}" == "noclone" ] && NOCLONE="y" && continue
tierno45a52852016-08-26 14:39:42 +0200101 [ "${OPTARG}" == "quiet" ] && export QUIET_MODE=yes && export DEBIAN_FRONTEND=noninteractive && continue
tierno76841842016-09-27 09:18:28 +0000102 [ "${OPTARG}" == "no-install-packages" ] && export NO_PACKAGES=yes && continue
tiernoc50e5da2016-07-06 17:49:45 +0200103 echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2
104 exit 1
105 ;;
106 \?)
107 echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2
108 exit 1
109 ;;
110 :)
111 echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2
112 exit 1
113 ;;
114 *)
115 usage >&2
garciadeblas89b3d842016-09-19 15:18:33 +0200116 exit 1
tiernoc50e5da2016-07-06 17:49:45 +0200117 ;;
118 esac
119done
garciadeblas16304ba2016-05-11 14:47:39 +0200120
tiernoc50e5da2016-07-06 17:49:45 +0200121#check root privileges and non a root user behind
garciadeblas89b3d842016-09-19 15:18:33 +0200122[ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit 1
tiernoc50e5da2016-07-06 17:49:45 +0200123if [[ -z "$SUDO_USER" ]] || [[ "$SUDO_USER" = "root" ]]
124then
125 [[ -z $QUIET_MODE ]] && read -e -p "Install in the root user (y/N)?" KK
126 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
127 export SUDO_USER=root
128fi
garciadeblas16304ba2016-05-11 14:47:39 +0200129
130#Discover Linux distribution
131#try redhat type
132[ -f /etc/redhat-release ] && _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1)
133#if not assuming ubuntu type
134[ -f /etc/redhat-release ] || _DISTRO=$(lsb_release -is 2>/dev/null)
135if [ "$_DISTRO" == "Ubuntu" ]
136then
tierno45a52852016-08-26 14:39:42 +0200137 _RELEASE=$(lsb_release -rs)
138 if [[ ${_RELEASE%%.*} != 14 ]] && [[ ${_RELEASE%%.*} != 16 ]]
garciadeblas16304ba2016-05-11 14:47:39 +0200139 then
tierno45a52852016-08-26 14:39:42 +0200140 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Ubuntu version. Continue assuming a trusty (14.XX)'? (y/N)" KK
tiernoc50e5da2016-07-06 17:49:45 +0200141 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
tierno45a52852016-08-26 14:39:42 +0200142 _RELEASE = 14
garciadeblas16304ba2016-05-11 14:47:39 +0200143 fi
144elif [ "$_DISTRO" == "CentOS" ]
145then
146 _RELEASE="7"
147 if ! cat /etc/redhat-release | grep -q "7."
148 then
tiernoc50e5da2016-07-06 17:49:45 +0200149 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested CentOS version. Continue assuming a '_RELEASE' type? (y/N)" KK
150 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200151 fi
152elif [ "$_DISTRO" == "Red" ]
153then
154 _RELEASE="7"
155 if ! cat /etc/redhat-release | grep -q "7."
156 then
tiernoc50e5da2016-07-06 17:49:45 +0200157 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Red Hat OS version. Continue assuming a '_RELEASE' type? (y/N)" KK
158 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200159 fi
160else #[ "$_DISTRO" != "Ubuntu" -a "$_DISTRO" != "CentOS" -a "$_DISTRO" != "Red" ]
161 _DISTRO_DISCOVER=$_DISTRO
162 [ -x /usr/bin/apt-get ] && _DISTRO="Ubuntu" && _RELEASE="14"
163 [ -x /usr/bin/yum ] && _DISTRO="CentOS" && _RELEASE="7"
tiernoc50e5da2016-07-06 17:49:45 +0200164 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Linux distribution '$_DISTRO_DISCOVER '. Continue assuming a '$_DISTRO $_RELEASE' type? (y/N)" KK
165 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200166fi
167
168
169
tierno76841842016-09-27 09:18:28 +0000170if [[ -z "$NO_PACKAGES" ]]
171then
garciadeblas16304ba2016-05-11 14:47:39 +0200172echo '
173#################################################################
174##### UPDATE REPOSITORIES #####
175#################################################################'
176[ "$_DISTRO" == "Ubuntu" ] && apt-get update -y
177
178[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum check-update -y
179[ "$_DISTRO" == "CentOS" ] && sudo yum install -y epel-release
180[ "$_DISTRO" == "Red" ] && wget http://dl.fedoraproject.org/pub/epel/7/x86_64/e/epel-release-7-5.noarch.rpm \
181 && sudo rpm -ivh epel-release-7-5.noarch.rpm && sudo yum install -y epel-release && rm -f epel-release-7-5.noarch.rpm
182[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && sudo yum repolist
183
tierno76841842016-09-27 09:18:28 +0000184fi
garciadeblas16304ba2016-05-11 14:47:39 +0200185
tierno76841842016-09-27 09:18:28 +0000186if [[ -z "$NO_PACKAGES" ]]
187then
garciadeblas16304ba2016-05-11 14:47:39 +0200188echo '
189#################################################################
190##### INSTALL REQUIRED PACKAGES #####
191#################################################################'
192[ "$_DISTRO" == "Ubuntu" ] && install_packages "git screen wget mysql-server"
193[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "git screen wget mariadb mariadb-server"
194
tiernoc50e5da2016-07-06 17:49:45 +0200195if [[ "$_DISTRO" == "Ubuntu" ]]
196then
197 #start services. By default CentOS does not start services
198 service mysql start >> /dev/null
199 # try to set admin password, ignore if fails
200 [[ -n $DBPASSWD ]] && mysqladmin -u $DBUSER -s password $DBPASSWD
201fi
202
garciadeblas16304ba2016-05-11 14:47:39 +0200203if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
204then
205 #start services. By default CentOS does not start services
206 service mariadb start
207 service httpd start
208 systemctl enable mariadb
209 systemctl enable httpd
210 read -e -p "Do you want to configure mariadb (recommended if not done before) (Y/n)" KK
211 [ "$KK" != "n" -a "$KK" != "no" ] && mysql_secure_installation
212
213 read -e -p "Do you want to set firewall to grant web access port 80,443 (Y/n)" KK
214 [ "$KK" != "n" -a "$KK" != "no" ] &&
215 firewall-cmd --permanent --zone=public --add-service=http &&
216 firewall-cmd --permanent --zone=public --add-service=https &&
217 firewall-cmd --reload
218fi
tierno76841842016-09-27 09:18:28 +0000219fi #[[ -z "$NO_PACKAGES" ]]
garciadeblas16304ba2016-05-11 14:47:39 +0200220
221#check and ask for database user password. Must be done after database installation
tiernoc50e5da2016-07-06 17:49:45 +0200222if [[ -n $QUIET_MODE ]]
223then
224 echo -e "\nCheking database connection and ask for credentials"
garciadeblas89b3d842016-09-19 15:18:33 +0200225 while ! mysqladmin -s -u$DBUSER $DBPASSWD_PARAM status >/dev/null
tiernoc50e5da2016-07-06 17:49:45 +0200226 do
garciadeblas16304ba2016-05-11 14:47:39 +0200227 [ -n "$logintry" ] && echo -e "\nInvalid database credentials!!!. Try again (Ctrl+c to abort)"
228 [ -z "$logintry" ] && echo -e "\nProvide database credentials"
229 read -e -p "database user? ($DBUSER) " DBUSER_
230 [ -n "$DBUSER_" ] && DBUSER=$DBUSER_
231 read -e -s -p "database password? (Enter for not using password) " DBPASSWD_
tiernoc50e5da2016-07-06 17:49:45 +0200232 [ -n "$DBPASSWD_" ] && DBPASSWD="$DBPASSWD_" && DBPASSWD_PARAM="-p$DBPASSWD_"
233 [ -z "$DBPASSWD_" ] && DBPASSWD="" && DBPASSWD_PARAM=""
garciadeblas16304ba2016-05-11 14:47:39 +0200234 logintry="yes"
tiernoc50e5da2016-07-06 17:49:45 +0200235 done
236fi
garciadeblas16304ba2016-05-11 14:47:39 +0200237
tierno76841842016-09-27 09:18:28 +0000238if [[ -z "$NO_PACKAGES" ]]
239then
garciadeblas16304ba2016-05-11 14:47:39 +0200240echo '
241#################################################################
242##### INSTALL PYTHON PACKAGES #####
243#################################################################'
bayramovfe3f3c92016-10-04 07:53:41 +0400244[ "$_DISTRO" == "Ubuntu" ] && install_packages "python-yaml python-bottle python-mysqldb python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxml2-dev libxslt-dev python-dev python-pip"
245[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "PyYAML MySQL-python python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxslt-devel libxml2-devel python-devel python-pip"
246
247#required for vmware connector TODO move that to separete opt in install script
248sudo pip install --upgrade pip
249sudo pip install pyvcloud
250sudo pip install progressbar
251sudo pip install prettytable
garciadeblas16304ba2016-05-11 14:47:39 +0200252
253#The only way to install python-bottle on Centos7 is with easy_install or pip
254[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && easy_install -U bottle
255
256#install openstack client needed for using openstack as a VIM
257[ "$_DISTRO" == "Ubuntu" ] && install_packages "python-novaclient python-keystoneclient python-glanceclient python-neutronclient"
258[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-devel" && easy_install python-novaclient python-keystoneclient python-glanceclient python-neutronclient #TODO revise if gcc python-pip is needed
tierno76841842016-09-27 09:18:28 +0000259fi #[[ -z "$NO_PACKAGES" ]]
garciadeblas16304ba2016-05-11 14:47:39 +0200260
garciadeblas89b3d842016-09-19 15:18:33 +0200261if [[ -z $NOCLONE ]]; then
262 echo '
garciadeblas16304ba2016-05-11 14:47:39 +0200263#################################################################
264##### DOWNLOAD SOURCE #####
265#################################################################'
garciadeblas89b3d842016-09-19 15:18:33 +0200266 su $SUDO_USER -c 'git clone '"${GIT_URL}"' openmano'
267 #[[ -z $DEVELOP ]] && su $SUDO_USER -c 'git checkout <tag version>'
268fi
garciadeblas16304ba2016-05-11 14:47:39 +0200269
270echo '
271#################################################################
272##### CREATE DATABASE #####
273#################################################################'
garciadeblas89b3d842016-09-19 15:18:33 +0200274echo -e "\nCreating temporary file form MYSQL installation and initialization"
275TEMPFILE="$(mktemp -q --tmpdir "installopenmano.XXXXXX")"
garciadeblas4b3b4462016-09-27 11:16:14 +0200276trap 'rm -f "$TEMPFILE"' EXIT
garciadeblas89b3d842016-09-19 15:18:33 +0200277chmod 0600 "$TEMPFILE"
278cat >"$TEMPFILE" <<EOF
279[client]
280user=$DBUSER
281password=$DBPASSWD
282EOF
garciadeblas16304ba2016-05-11 14:47:39 +0200283
tierno12b1f742016-09-19 15:43:53 +0000284if db_exists "mano_db" $TEMPFILE ; then
garciadeblas89b3d842016-09-19 15:18:33 +0200285 if [[ -n $FORCEDB ]]; then
286 echo " Deleting previous database mano_db"
287 DBDELETEPARAM=""
288 [[ -n $QUIET_MODE ]] && DBDELETEPARAM="-f"
289 mysqladmin --defaults-extra-file=$TEMPFILE -s drop mano_db $DBDELETEPARAM || ! echo "Could not delete mano_db database" || exit 1
290 #echo "REVOKE ALL PRIVILEGES ON mano_db.* FROM 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
291 #echo "DELETE USER 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
292 mysqladmin --defaults-extra-file=$TEMPFILE -s create mano_db || ! echo "Error creating mano_db database" || exit 1
293 echo "DROP USER 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
294 echo "CREATE USER 'mano'@'localhost' identified by 'manopw';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
295 echo "GRANT ALL PRIVILEGES ON mano_db.* TO 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
296 echo " Database 'mano_db' created, user 'mano' password 'manopw'"
297 else
298 echo "Database exists. Use option '--forcedb' to force the deletion of the existing one" && exit 1
299 fi
300else
tierno12b1f742016-09-19 15:43:53 +0000301 mysqladmin -u$DBUSER $DBPASSWD_PARAM -s create mano_db || ! echo "Error creating mano_db database" || exit 1
garciadeblas89b3d842016-09-19 15:18:33 +0200302 echo "CREATE USER 'mano'@'localhost' identified by 'manopw';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
303 echo "GRANT ALL PRIVILEGES ON mano_db.* TO 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
304 echo " Database 'mano_db' created, user 'mano' password 'manopw'"
305fi
garciadeblas16304ba2016-05-11 14:47:39 +0200306
garciadeblas89b3d842016-09-19 15:18:33 +0200307
garciadeblas6409b4b2016-09-19 22:54:40 +0200308#Next operations require knowing OPENMANO_BASEFOLDER
309HERE=$(realpath $(dirname $0))
310if [[ -z $NOCLONE ]]; then
311 OPENMANO_BASEFOLDER="${HERE}/openmano"
312else
313 OPENMANO_BASEFOLDER=$(dirname $HERE)
314fi
315
316
garciadeblas89b3d842016-09-19 15:18:33 +0200317echo '
318#################################################################
319##### INIT DATABASE #####
320#################################################################'
garciadeblas89b3d842016-09-19 15:18:33 +0200321su $SUDO_USER -c "${OPENMANO_BASEFOLDER}"'/database_utils/init_mano_db.sh -u mano -p manopw -d mano_db' || ! echo "Failed while initializing database" || exit 1
322
garciadeblas16304ba2016-05-11 14:47:39 +0200323
324if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
325then
326 echo '
327#################################################################
328##### CONFIGURE firewalld #####
329#################################################################'
tiernoc50e5da2016-07-06 17:49:45 +0200330 KK=yes
331 [[ -z $QUIET_MODE ]] && read -e -p "Configure firewalld for openmanod port 9090? (Y/n)" KK
garciadeblas16304ba2016-05-11 14:47:39 +0200332 if [ "$KK" != "n" -a "$KK" != "no" ]
333 then
334 #Creates a service file for openmano
335 echo '<?xml version="1.0" encoding="utf-8"?>
336<service>
337 <short>openmanod</short>
338 <description>openmanod service</description>
339 <port protocol="tcp" port="9090"/>
340</service>' > /etc/firewalld/services/openmanod.xml
341 #put proper permissions
342 pushd /etc/firewalld/services > /dev/null
343 restorecon openmanod.xml
344 chmod 640 openmanod.xml
345 popd > /dev/null
346 #Add the openmanod service to the default zone permanently and reload the firewall configuration
347 firewall-cmd --permanent --add-service=openmanod > /dev/null
348 firewall-cmd --reload > /dev/null
349 echo "done."
350 else
351 echo "skipping."
352 fi
353fi
354
355echo '
356#################################################################
357##### CONFIGURE OPENMANO CLIENT #####
358#################################################################'
359#creates a link at ~/bin
tiernoc50e5da2016-07-06 17:49:45 +0200360su $SUDO_USER -c 'mkdir -p ${HOME}/bin'
361su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano'
garciadeblas89b3d842016-09-19 15:18:33 +0200362su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano-report'
tiernoc50e5da2016-07-06 17:49:45 +0200363su $SUDO_USER -c 'rm -f ${HOME}/bin/service-openmano'
garciadeblas89b3d842016-09-19 15:18:33 +0200364su $SUDO_USER -c 'ln -s '${OPENMANO_BASEFOLDER}'/openmano ${HOME}/bin/openmano'
365su $SUDO_USER -c 'ln -s '${OPENMANO_BASEFOLDER}'/scripts/openmano-report.sh ${HOME}/bin/openmano-report'
366su $SUDO_USER -c 'ln -s '${OPENMANO_BASEFOLDER}'/scripts/service-openmano.sh ${HOME}/bin/service-openmano'
garciadeblas16304ba2016-05-11 14:47:39 +0200367
368#insert /home/<user>/bin in the PATH
369#skiped because normally this is done authomatically when ~/bin exist
tiernoc50e5da2016-07-06 17:49:45 +0200370#if ! su $SUDO_USER -c 'echo $PATH' | grep -q "${HOME}/bin"
garciadeblas16304ba2016-05-11 14:47:39 +0200371#then
372# echo " inserting /home/$SUDO_USER/bin in the PATH at .bashrc"
tiernoc50e5da2016-07-06 17:49:45 +0200373# su $SUDO_USER -c 'echo "PATH=\$PATH:\${HOME}/bin" >> ~/.bashrc'
garciadeblas16304ba2016-05-11 14:47:39 +0200374#fi
tiernoc50e5da2016-07-06 17:49:45 +0200375if [[ $SUDO_USER == root ]]
376then
377 if ! echo $PATH | grep -q "${HOME}/bin"
378 then
379 echo "PATH=\$PATH:\${HOME}/bin" >> ${HOME}/.bashrc
380 fi
381fi
garciadeblas16304ba2016-05-11 14:47:39 +0200382
383#configure arg-autocomplete for this user
384#in case of minimal instalation this package is not installed by default
385[[ "$_DISTRO" == "CentOS" || "$_DISTRO" == "Red" ]] && yum install -y bash-completion
386#su $SUDO_USER -c 'mkdir -p ~/.bash_completion.d'
387su $SUDO_USER -c 'activate-global-python-argcomplete --user'
tiernoc50e5da2016-07-06 17:49:45 +0200388if ! su $SUDO_USER -c 'grep -q bash_completion.d/python-argcomplete.sh ${HOME}/.bashrc'
garciadeblas16304ba2016-05-11 14:47:39 +0200389then
390 echo " inserting .bash_completion.d/python-argcomplete.sh execution at .bashrc"
tiernoc50e5da2016-07-06 17:49:45 +0200391 su $SUDO_USER -c 'echo ". ${HOME}/.bash_completion.d/python-argcomplete.sh" >> ~/.bashrc'
garciadeblas16304ba2016-05-11 14:47:39 +0200392fi
393
tierno45a52852016-08-26 14:39:42 +0200394
395
396
397if [[ "$_DISTRO" == "Ubuntu" ]] && [[ ${_RELEASE%%.*} == 16 ]] && [[ -z $DEVELOP ]]
398then
399echo '
400#################################################################
401##### CONFIGURE OPENMANO SERVICE #####
402#################################################################'
403
garciadeblas89b3d842016-09-19 15:18:33 +0200404 ${OPENMANO_BASEFOLDER}/scripts/install-openmano-service.sh -f ${OPENMANO_BASEFOLDER} #-u $SUDO_USER
tierno45a52852016-08-26 14:39:42 +0200405# alias service-openmano="service openmano"
406# echo 'alias service-openmano="service openmano"' >> ${HOME}/.bashrc
407
408 echo
409 echo "Done! you may need to logout and login again for loading client configuration"
410 echo " Manage server with 'service openmano start|stop|status|...' "
411
412
413else
414
415 echo
416 echo "Done! you may need to logout and login again for loading client configuration"
417 echo " Run './openmano/scripts/service-openmano.sh start' for starting openmano in a screen"
418
419fi
garciadeblas16304ba2016-05-11 14:47:39 +0200420
421
422